;#########################################################################################################
;###################*******************************#######################################################
;###################  B L I N D         C R Y P T  #######################################################
;###################  blind_crypt.tnick@yahoo.com  #######################################################
;###################_______________________________#######################################################
;#########################################################################################################

;
;					# Settings file.asm #
;
.386
option casemap:none
.CODE


FS_Open		proc
;it creates the path to the settings file, try to open that file and, if it can't, 
;it tries to create the file there, calling the appropriate proc
	
	mov		ecx,			pCommandLine
	mov		edx,			pBuffer_1000h
	;copy the path and name for the execuutable in buffer; find where the last \ is
	.WHILE	byte ptr [ecx]!=0
		inc		ecx
		mov		al,				byte ptr [ecx]
		.BREAK	.IF	al==22h
		mov		byte ptr [edx],	al
		inc		edx
		.IF		al=="\"	
			mov		hFile_Settings,		edx 
		.ENDIF		
	.ENDW
	
	;add "Data" tothis path
	mov		edx,			hFile_Settings
	mov		dword ptr [edx],"ataD"
	mov		byte  ptr [edx+4],0
	;be shure that there is this path
	INVOKE	CreateDirectory,pBuffer_1000h,0
	mov		edx,			hFile_Settings
	;add "\Setari.cfg" to the buffer
	mov		dword ptr [edx+ 4],	"teS\"
	mov		dword ptr [edx+ 8],	".ira"
	mov		dword ptr [edx+12],	"0gfc"	
	mov		byte ptr [edx+15],	0
	;try to open the file
	INVOKE	CreateFile,		pBuffer_1000h,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,0,0
	mov		hFile_Settings,			eax
	.IF		eax==INVALID_HANDLE_VALUE
		;maybe we can create the file
		INVOKE	CreateFile,		pBuffer_1000h,GENERIC_READ or GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
		mov		hFile_Settings,			eax
		.IF		eax!=INVALID_HANDLE_VALUE
			;default values
			INVOKE	FS_CreateNew
		.endif
	.ENDIF
	;read settings
	INVOKE	SetFilePointer,	hFile_Settings,0,0,FILE_BEGIN
	mov		eax,			pBuffer_1000h
	add		eax,			(FS_Poz_SecWin+20h)
	INVOKE	ReadFile,		hFile_Settings,pBuffer_1000h,(FS_Poz_SecWin+8),eax,0
	.IF		eax==0
		mov		PozXWinSec,		300
		mov		PozYWinSec,		200
	.ELSE
		mov		eax,			pBuffer_1000h
		mov		ecx,			dword ptr [eax+FS_Poz_SecWin]
		mov		edx,			dword ptr [eax+FS_Poz_SecWin+4]
		mov		PozXWinSec,		ecx
		mov		PozYWinSec,		edx
	.endif
ret
FS_Open 		endp	
	
FS_CreateNew		proc
;it writes default values in a settings file; it need a valid handle 
;for the file
LOCAL	Answer		:DWORD	;used by the WriteFIle
	
	mov		ecx,				pBuffer_1000h
	;default values for main window position
	mov		(RECT ptr [ecx+FS_Poz_MainWin]).left,	100
	mov		(RECT ptr [ecx+FS_Poz_MainWin]).top,	100
	mov		(RECT ptr [ecx+FS_Poz_MainWin]).right,	640
	mov		(RECT ptr [ecx+FS_Poz_MainWin]).bottom,	480
	;default values for sec. window position
	mov		(RECT ptr [ecx+FS_Poz_SecWin]).left,	300
	mov		(RECT ptr [ecx+FS_Poz_SecWin]).top,		200
	
	
	;write this values
	INVOKE	SetFilePointer,		hFile_Settings,0,0,FILE_BEGIN
	INVOKE	WriteFile,			hFile_Settings,pBuffer_1000h,FS_AtLeast,addr Answer,0
	.IF			eax==0
		;error message
		INVOKE	MessageBox,	0,addr Err_00,0,MB_OK
	.ENDIF
ret
FS_CreateNew endp

FS_SaveAtTheEnd		proc
;write before exit the values that must be saved
;it need a valid handle for the file
LOCAL	Answer		:DWORD
	
	INVOKE		ShowWindow,			hWndMain,SW_RESTORE
	;position of the main window
	INVOKE		GetWindowRect,		hWndMain,pBuffer_1000h
	mov			ecx,				pBuffer_1000h
	mov			eax,				(RECT ptr [ecx]).left
	mov			edx,				(RECT ptr [ecx]).top
	sub			(RECT ptr [ecx]).right,		eax
	sub			(RECT ptr [ecx]).bottom,	edx
	add			ecx,				FS_Poz_SecWin
	;position of the sec. window
	mov			eax,				PozXWinSec
	mov			edx,				PozYWinSec
	mov			dword ptr [ecx],	eax
	mov			dword ptr [ecx+4],	edx	
	;write those values
	INVOKE		SetFilePointer,		hFile_Settings,0,0,FILE_BEGIN
	INVOKE		WriteFile,			hFile_Settings,pBuffer_1000h,FS_AtLeast,addr Answer,0
ret
FS_SaveAtTheEnd endp




















