;#########################################################################################################
;###################*******************************#######################################################
;###################  B L I N D         C R Y P T  #######################################################
;###################  blind_crypt.tnick@yahoo.com  #######################################################
;###################_______________________________#######################################################
;#########################################################################################################

;
;					# Blind Crypt V1.1.Asm #
;
.386
.model flat, stdcall
option casemap:none

	INCLUDE Blind Crypt V1.1.Inc


.CODE
;
;			THIS IS WHERE ALL BEGINS
;

ENTRY_POINT_BC:
	;crt instance
	INVOKE	GetModuleHandle,NULL
	mov		hInstance,		eax
	;pointer to the command line
	INVOKE	GetCommandLine
	mov		pCommandLine,		eax
	;main thread handle
	INVOKE	GetCurrentThreadId
	mov		IDTH_Main,		eax
	;my own personal heap
	INVOKE	HeapCreate,		0,DimInitHeap,0
	mov		hHeap,			eax
	or		eax,			eax
	jz		GetOutEntryPoint
	;general purpose buffer
	INVOKE	HeapAlloc,		hHeap,0,1000h
	mov		pBuffer_1000h,	eax
	or		eax,			eax
	jz		GetOutEntryPoint	
	;settings file must be opened
	INVOKE	FS_Open
	;menus
	INVOKE	MenuCreation
	;main window
	INVOKE	MainW_Create
	or		eax,			eax
	jz		GetOutEntryPoint
	cmp		hWndMain,		0
	je		GetOutEntryPoint
	;get ready the pens, brushes, etc
	INVOKE	GraphObj_Create
	or		eax,			eax
	jz		GetOutEntryPoint
	;main window elements
	INVOKE	CreateMWinComponents
	;show that no project is loaded
	INVOKE	ShowInterface,		ShowType_NoPrj
	
	
	
	
	;start the loop
	INVOKE	Message_Loop
	mov		hWndMain,	eax
	
	
	
	
	GetOutEntryPoint:
	.IF		hBTM_Img!=0
		INVOKE	DeleteObject,hBTM_Img
	.ENDIF
	.IF		hDCBuffImg!=0
		INVOKE	DeleteDC,	hDCBuffImg
	.ENDIF
	;close the settings file
	INVOKE	CloseHandle,hFile_Settings
	;destroy graphics
	INVOKE	GraphObj_Destroy
	;destroy the heap
	INVOKE	HeapDestroy,	hHeap
	;exit the program
	INVOKE	ExitProcess,	hWndMain
END ENTRY_POINT_BC