;#########################################################################################################
;###################*******************************#######################################################
;###################  B L I N D         C R Y P T  #######################################################
;###################  blind_crypt.tnick@yahoo.com  #######################################################
;###################_______________________________#######################################################
;#########################################################################################################

;
;					# Prj work.asm #
;
.386
option casemap:none
.CODE

OpenNewPrj	proc	uses ebx
;it ask for a path and a name for the new project file;
;then, it create the file, close the old project, ask for a pass and change the title bar and
;other visual aspects
LOCAL	OFN				:OPENFILENAME		;guess what it does...
LOCAL	pPathNameNew	:DWORD

	INVOKE	HeapAlloc,				hHeap,0,500h
	mov		pPathNameNew,			eax
	or		eax,					eax
	jz		GetOutOfHere
	;get ready to let the user choose the file
	mov		OFN.lStructSize,		SIZEOF OPENFILENAME
	mov		eax,					hWndMain
	mov		OFN.hwndOwner,			eax
	mov		eax,					hInstance
	mov		OFN.hInstance,			eax
	mov		OFN.lpstrFilter,		OFFSET Filter_Prj
	mov		OFN.lpstrCustomFilter,	0
	mov		OFN.nMaxCustFilter,		0
	mov		OFN.nFilterIndex,		1
	mov		eax,					pPathNameNew
	mov		dword ptr [eax],		0
	mov		OFN.lpstrFile,			eax
	mov		OFN.nMaxFile,			500h
	mov		OFN.lpstrFileTitle,		0
	mov		OFN.nMaxFileTitle,		0
	mov		OFN.lpstrInitialDir,	0
	mov		OFN.lpstrTitle,			OFFSET Title_NewPrj
	mov		OFN.Flags,				OFN_OVERWRITEPROMPT or OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON
	mov		OFN.lpstrDefExt,		0
	mov		OFN.lCustData,			0
	mov		OFN.lpfnHook,			0
	mov		OFN.lpTemplateName,		0
	;choose now
	INVOKE	GetSaveFileName,		addr OFN
	;no error, no cancel,...
	.IF		eax!=0
		;another project opened?
		INVOKE	ClosePrj
		;a new project => a new pass
		INVOKE	PasswWork,		AddPassType_Prj_Add
		;no? get out
		or		eax,			eax
		jz		GetOutOfHere
		;no need for old project's memory
		.IF		pPathName_CrtPrj!=-1
			INVOKE	HeapFree,		hHeap,0,pPathName_CrtPrj
		.ENDIF
		;path and name for new project
		xor		ebx,			ebx
		mov		bx,				OFN.nFileOffset
		mov		edx,			pPathNameNew
		.WHILE	byte ptr [edx+ebx]!=0
			inc		ebx
		.ENDW
		inc		ebx	
		mov		OFN.nFileOffset,bx
		add		ebx,			2
		;memory for the path and name
		INVOKE	HeapAlloc,		hHeap,0,ebx
		mov		pPathName_CrtPrj,eax
		mov		edx,			pPathNameNew
		mov		word ptr [eax],	bx
		sub		word ptr [eax],	2
		add		eax,			2
		xor		ebx,			ebx
		.WHILE	bx<OFN.nFileOffset
			mov		cl,				byte ptr [edx+ebx]
			mov		byte ptr [eax+ebx],cl
			inc		ebx
		.ENDW
		mov		ebx,			edx
		;loop Retry-Cancel
		.WHILE	hFilePrj==-1
			;to create the file
			INVOKE	CreateFile,		ebx,GENERIC_READ or GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
			mov		hFilePrj,	eax
			.IF		hFilePrj==-1
				;not ok? message
				INVOKE	MessageBox,hWndMain,ADDR Err_10,ebx,MB_RETRYCANCEL
				cmp		eax,		IDCANCEL
				je		GetOutOfHere
			.ENDIF
		.ENDW
		;new titlebar
		mov		edx,			pBuffer_1000h
		mov		ecx,			OFFSET AppName
		mov		al,				1
		.WHILE	al!=0
			mov		al,				byte ptr [ecx]
			mov		byte ptr [edx],	al
			inc		ecx
			inc		edx
		.ENDW
		dec		edx
		mov		dword ptr [edx],	"[ - "
		add		edx,				4
		mov		al,					1
		mov		ecx,				pPathName_CrtPrj
		add		ecx,				2
		.WHILE	al!=0
			mov		al,				byte ptr [ecx]
			mov		byte ptr [edx],	al
			inc		ecx
			inc		edx
		.ENDW
		dec		edx
		mov		byte ptr [edx],		"]"
		mov		byte ptr [edx+1],	0
		INVOKE	SendMessage,		hWndMain,WM_SETTEXT,0,pBuffer_1000h
		;visual aspects
		INVOKE	ShowInterface,	ShowType_WithPrj
	.ENDIF
	
GetOutOfHere:
.IF pPathNameNew!=0
	INVOKE	HeapFree,	hHeap,0,pPathNameNew
.ENDIF
ret
OpenNewPrj 	endp

OpenPrj		proc	uses ebx
;this baby let's you choose a project to be opened; the file is readed,
;old project is closed, password is requested, the title bar is updated,
;the files are passed to the list and extended memory is alocated and initializated
LOCAL	OFN			:OPENFILENAME	;   :)
LOCAL	pPathName	:DWORD

	INVOKE	HeapAlloc,				hHeap,0,500h
	mov		pPathName,				eax
	or		eax,					eax
	jz		GetOutOfHere
	;initiate the structure
	mov		OFN.lStructSize,		SIZEOF OPENFILENAME
	mov		eax,					hWndMain
	mov		OFN.hwndOwner,			eax
	mov		eax,					hInstance
	mov		OFN.hInstance,			eax
	mov		OFN.lpstrFilter,		OFFSET Filter_Prj
	mov		OFN.lpstrCustomFilter,	0
	mov		OFN.nMaxCustFilter,		0
	mov		OFN.nFilterIndex,		1
	mov		eax,					pPathName
	mov		dword ptr [eax],		0
	mov		OFN.lpstrFile,			eax
	mov		OFN.nMaxFile,			500h
	mov		OFN.lpstrFileTitle,		0
	mov		OFN.nMaxFileTitle,		0
	mov		OFN.lpstrInitialDir,	0
	mov		OFN.lpstrTitle,			OFFSET Title_OpenPrj
	mov		OFN.Flags,				OFN_LONGNAMES or OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON
	mov		OFN.lpstrDefExt,		0
	mov		OFN.lCustData,			0
	mov		OFN.lpfnHook,			0
	mov		OFN.lpTemplateName,		0
	;let the user choose the file
	INVOKE	GetOpenFileName,		addr OFN
	;no cancel, no escape, no error
	.IF		eax!=0
		;close the loaded project 
		INVOKE	ClosePrj
		;ask for a pass
		INVOKE	PasswWork,		AddPassType_Prj_Enter
		;thanks
		.IF		eax==1
			;old project name
			.IF		pPathName_CrtPrj!=-1
				INVOKE	HeapFree,		hHeap,0,pPathName_CrtPrj
			.ENDIF
			;save the path and name for new file
			xor		ebx,			ebx
			mov		bx,				OFN.nFileOffset
			mov		edx,			pPathName
			.WHILE	byte ptr [edx+ebx]!=0
				inc		ebx
			.ENDW
			inc		ebx
			mov		OFN.nFileOffset,bx
			add		ebx,			2
			INVOKE	HeapAlloc,		hHeap,0,ebx
			mov		pPathName_CrtPrj,eax
			mov		edx,			pPathName
			mov		word ptr [eax],	bx
			sub		word ptr [eax],	2
			add		eax,			2
			xor		ebx,			ebx
			.WHILE	bx<OFN.nFileOffset
				mov		cl,				byte ptr [edx+ebx]
				mov		byte ptr [eax+ebx],cl
				inc		ebx
			.ENDW
			mov		ebx,			edx	
			;get a handle to that file
			.WHILE	hFilePrj==-1
				INVOKE	CreateFile,		ebx,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
				mov		hFilePrj,	eax
				.IF		hFilePrj==-1
					INVOKE	MessageBox,hWndMain,ADDR Err_11,ebx,MB_RETRYCANCEL
					cmp		eax,		IDCANCEL
					je		GetOutOfHere
				.ENDIF
			.ENDW
			;update the title bar
			mov		edx,			pBuffer_1000h
			mov		ecx,			OFFSET AppName
			mov		al,				1
			.WHILE	al!=0
				mov		al,				byte ptr [ecx]
				mov		byte ptr [edx],	al
				inc		ecx
				inc		edx
			.ENDW
			dec		edx
			mov		dword ptr [edx],	"[ - "
			add		edx,				4
			mov		al,					1
			mov		ecx,				pPathName_CrtPrj
			add		ecx,				2
			.WHILE	al!=0
				mov		al,				byte ptr [ecx]
				mov		byte ptr [edx],	al
				inc		ecx
				inc		edx
			.ENDW
			dec		edx
			mov		byte ptr [edx],		"]"
			mov		byte ptr [edx+1],	0
			INVOKE	SendMessage,		hWndMain,WM_SETTEXT,0,pBuffer_1000h
			;load the project
			INVOKE	LoadPrj
			; ... ... 
			INVOKE	ShowInterface,	ShowType_WithPrj
		.ENDIF
	.ENDIF
GetOutOfHere:
.IF	pPathName!=0
	INVOKE	HeapFree,	hHeap,0,pPathName
.ENDIF
ret
OpenPrj 		endp

SavePrjAs		proc		uses ebx esi edi
;save the loaded project under a diffrent name
LOCAL	OFN		:OPENFILENAME

	;be ready ....
	mov		OFN.lStructSize,		SIZEOF OPENFILENAME
	mov		eax,					hWndMain
	mov		OFN.hwndOwner,			eax
	mov		eax,					hInstance
	mov		OFN.hInstance,			eax
	mov		OFN.lpstrFilter,		OFFSET Filter_Prj
	mov		OFN.lpstrCustomFilter,	0
	mov		OFN.nMaxCustFilter,		0
	mov		OFN.nFilterIndex,		1
	mov		eax,					pBuffer_1000h
	mov		dword ptr [eax],		0
	mov		OFN.lpstrFile,			eax
	mov		OFN.nMaxFile,			1000h
	mov		OFN.lpstrFileTitle,		0
	mov		OFN.nMaxFileTitle,		0
	mov		OFN.lpstrInitialDir,	0
	mov		OFN.lpstrTitle,			OFFSET Title_SaveAs
	mov		OFN.Flags,				OFN_OVERWRITEPROMPT or OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON
	mov		OFN.lpstrDefExt,		0
	mov		OFN.lCustData,			0
	mov		OFN.lpfnHook,			0
	mov		OFN.lpTemplateName,		0
	;GO!
	INVOKE	GetSaveFileName,		addr OFN
	;no err, cancel, ...
	.IF		eax!=0
		;save the loaded project
		INVOKE	SavePrjToDisk
		;close related material
		INVOKE	CloseHandle,		hFilePrj
		.IF		pPathName_CrtPrj!=-1
			INVOKE	HeapFree,		hHeap,0,pPathName_CrtPrj
		.ENDIF
		;find the end of the string
		xor		ebx,			ebx
		mov		bx,				OFN.nFileOffset
		mov		edx,			pBuffer_1000h
		.WHILE	byte ptr [edx+ebx]!=0
			inc		ebx
		.ENDW
		inc		ebx
		mov		OFN.nFileOffset,bx
		add		ebx,			2
		;memory for path and name
		INVOKE	HeapAlloc,		hHeap,0,ebx
		mov		pPathName_CrtPrj,eax
		mov		edx,			pBuffer_1000h
		mov		word ptr [eax],	bx
		add		eax,			2
		xor		ebx,			ebx
		.WHILE	bx<OFN.nFileOffset
			mov		cl,				byte ptr [edx+ebx]
			mov		byte ptr [eax+ebx],cl
			inc		ebx
		.ENDW
		mov		ebx,			edx	
		;create the file
		.WHILE	hFilePrj==-1
			INVOKE	CreateFile,		ebx,GENERIC_READ or GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
			mov		hFilePrj,	eax
			.IF		hFilePrj==-1
				INVOKE	MessageBox,hWndMain,ADDR Err_10,ebx,MB_RETRYCANCEL
				.IF		eax==IDCANCEL	
					ret
				.endif
			.ENDIF
		.ENDW
		;update titlebar
		mov		edx,			pBuffer_1000h
		mov		ecx,			OFFSET AppName
		mov		al,				1
		.WHILE	al!=0
			mov		al,				byte ptr [ecx]
			mov		byte ptr [edx],	al
			inc		ecx
			inc		edx
		.ENDW
		dec		edx
		mov		dword ptr [edx],	"[ - "
		add		edx,				4
		mov		al,					1
		mov		ecx,				pPathName_CrtPrj
		add		ecx,				2
		.WHILE	al!=0
			mov		al,				byte ptr [ecx]
			mov		byte ptr [edx],	al
			inc		ecx
			inc		edx
		.ENDW
		dec		edx
		mov		byte ptr [edx],		"]"
		mov		byte ptr [edx+1],	0
		INVOKE	SendMessage,		hWndMain,WM_SETTEXT,0,pBuffer_1000h
	.ENDIF
	
ret
SavePrjAs 		endp

ClosePrj		proc
;save the project, close the handle, visual aspects 
	
	.IF		hFilePrj!=-1
		INVOKE	SavePrjToDisk
		INVOKE	CloseHandle,		hFilePrj
		mov		hFilePrj,		-1
	.ENDIF	
	INVOKE	ShowInterface,	ShowType_NoPrj
	INVOKE	SendMessage,		hWndMain,WM_SETTEXT,0,ADDR AppName
ret
ClosePrj 	endp

LoadPrj		proc	uses esi edi ebx
;it decodes the file, using the pass the user entered; then, it loads all those files 
;into the list, along with the properties they have
LOCAL	CounterVar			:DWORD	;just a counter
LOCAL	Answer				:DWORD	;just an answer ... for reading
LOCAL	IdxElemL			:DWORD	;index of the element 
	
	INVOKE	SetFilePointer,		hFilePrj,0,0,FILE_BEGIN
	mov		esi,				pBuffer_1000h
	;let's decode this file
	INVOKE	GetFileSize,		hFilePrj,0
	mov		CounterVar,				eax
	mov		IdxElemL,			0
	.WHILE	CounterVar>1000h
		INVOKE	ReadFile,			hFilePrj,esi,1000h,ADDR Answer,0
		or		eax,				eax
		jz		IesireErr
		xor		edx,				edx
		mov		eax,				OFFSET PrjPassword
		xor		ecx,				ecx
		mov		cl,					byte ptr [eax]
		.WHILE	edx<1000h
			add		ecx,				edx
			rol		dword ptr [esi+edx],cl
			add		edx,				4
		.ENDW
		INVOKE	SetFilePointer,		hFilePrj,IdxElemL,0,FILE_BEGIN
		INVOKE	WriteFile,			hFilePrj,esi,1000h,ADDR Answer,0
		or		eax,				eax
		jz		IesireErr
		sub		CounterVar,				1000h
		add		IdxElemL,			1000h
	.ENDW
	INVOKE	ReadFile,			hFilePrj,esi,CounterVar,ADDR Answer,0
	or		eax,				eax
	jz		IesireErr
	xor		edx,				edx
	mov		eax,				OFFSET PrjPassword
	xor		ecx,				ecx
	mov		cl,					byte ptr [eax]
	.WHILE	edx<CounterVar
		add		ecx,				edx
;		rol		dword ptr [esi+edx],cl
;		add		edx,				4
		rol		byte ptr [esi+edx],cl
		add		edx,				1
	.ENDW
	INVOKE	SetFilePointer,		hFilePrj,IdxElemL,0,FILE_BEGIN
	INVOKE	WriteFile,			hFilePrj,esi,CounterVar,ADDR Answer,0
	or		eax,				eax
	jz		IesireErr
	or		eax,				eax
	jz		IesireErr
	
	
	;read the header (not much information, but still,a header)
	INVOKE	SetFilePointer,		hFilePrj,0,0,FILE_BEGIN
	INVOKE	ReadFile,			hFilePrj,esi,FilePrj_DimHeader+8,ADDR Answer,0
	or		eax,				eax
	jz		IesireErr
	sub		Answer,			8
	;number of items
	mov		eax,				dword ptr [esi+FilePrj_NumOfItems]
	mov		CounterVar,				eax
	;version - needs work here
	mov		eax,				dword ptr [esi+FilePrj_Version]
	.IF		eax!=APP_VERSION
		INVOKE	MessageBox,		hWndMain,ADDR Err_1B,0,MB_OK or MB_ICONERROR
		INVOKE	ClosePrj
		ret
	.endif
	; loop 
	.WHILE	CounterVar>0
		dec		CounterVar
		mov		ecx,				Answer
		mov		eax,				dword ptr [esi+ecx]
		mov		edx,				dword ptr [esi+ecx+4]
		mov		dword ptr [esi],	eax
		mov		dword ptr [esi+4],	edx
		add		edx,				eax
		add		edx,				11
		mov		ecx,				esi
		add		ecx,				8
		;next item
		INVOKE	ReadFile,			hFilePrj,ecx,edx,ADDR Answer,0
		or		eax,				eax
		jz		IesireErr
		mov		eax,				esi
		add		eax,				10
		;file go to the list
		INVOKE	SendMessage,		hWnd_List_Gen,LB_ADDSTRING,0,eax
		cmp		eax,				LB_ERR
		je		IesireErr
		mov		IdxElemL,			eax
		;extended memory as neded
		mov		eax,				dword ptr [esi+4]
		add		eax,				Ptr_MExtra_MaskName
		INVOKE	HeapAlloc,			hHeap,0,eax
		or		eax,				eax
		jz		IesireErr
		;status
		mov		dl,					byte ptr [esi+8]
		mov		byte ptr [eax+Ptr_MExtra_Status],dl
		;password
		.IF		byte ptr [esi+9]==0
			mov		dword ptr [eax+Ptr_MExtra_Pass],	MExtra_Pass_Without
		.ELSE
			mov		dword ptr [eax+Ptr_MExtra_Pass],	MExtra_Pass_NotInM
		.ENDIF
		;mask file
		mov		edi,				esi
		add		edi,				dword ptr [esi]
		add		edi,				11
		xor		ecx,				ecx
		.WHILE	ecx<dword ptr [esi+4]
			mov		dl,					byte ptr [edi+ecx]
			mov		byte ptr [eax+ecx+Ptr_MExtra_MaskName],	dl
			inc		ecx
		.ENDW
		mov		word ptr [eax+Ptr_MExtra_DimMaskName],cx
		;ready
		INVOKE	SendMessage,		hWnd_List_Gen,LB_SETITEMDATA,IdxElemL,eax
		cmp		eax,				LB_ERR
		je		IesireErr
	.ENDW
	
ret
;is there a error?
IesireErr:
INVOKE	MessageBox,		0,ADDR Err_01,0,MB_OK or MB_ICONERROR
ret
LoadPrj 		endp

SavePrjToDisk		proc	uses esi edi ebx
;it saves in the project file path and name for files and aditional
;info; at the end, the file is encoded, based on the pass for the project
LOCAL	CounterVar		:DWORD	;counter
LOCAL	Answer			:DWORD	;used in WriteFile
LOCAL	IdxElemL		:DWORD	;indexfor the intem in the list
	
	mov		esi,				pBuffer_1000h
	;values in the header
	xor		ecx,				ecx
	.WHILE	ecx<FilePrj_DimHeader
		mov		byte ptr [esi+ecx],0FFh
		inc		ecx
	.ENDW
	;number of items in the list
	INVOKE	SendMessage,		hWnd_List_Gen,LB_GETCOUNT,0,0
	cmp		eax,				LB_ERR
	je		IesireErr
	mov		dword ptr [esi+FilePrj_NumOfItems],eax
	mov		CounterVar,				eax
	;version
	mov		eax,				APP_VERSION
	mov		dword ptr [esi+FilePrj_Version],eax
	;and write the header
	INVOKE	SetFilePointer,		hFilePrj,0,0,FILE_BEGIN
	INVOKE	WriteFile,			hFilePrj,esi,FilePrj_DimHeader,ADDR Answer,0
	or		eax,				eax
	jz		IesireErr
	.WHILE	CounterVar>0
		mov		eax,				esi
		dec		CounterVar
		add		eax,				10
		;path and name for the real file
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETTEXT,CounterVar,eax
		cmp		eax,				LB_ERR
		je		IesireErr
		mov		dword ptr [esi],	eax
		;pointer to extended memory
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETITEMDATA,CounterVar,0
		cmp		eax,				LB_ERR
		je		IesireErr
		;status
		mov		dl,					byte ptr [eax+Ptr_MExtra_Status]
		mov		byte ptr [esi+8],	dl
		;password
		.IF		dword ptr [eax+Ptr_MExtra_Pass]==MExtra_Pass_Without
			mov		byte ptr [esi+9],	0
		.ELSE
			mov		byte ptr [esi+9],	1
		.ENDIF
		;mask file
		mov		edi,				esi
		add		edi,				11
		add		edi,				dword ptr [esi]
		xor		ecx,				ecx
		.WHILE	cx<word ptr [eax+Ptr_MExtra_DimMaskName]
			mov		dl,					byte ptr [eax+ecx+Ptr_MExtra_MaskName]
			mov		byte ptr [edi+ecx],	dl
			inc		ecx
		.ENDW
		mov		dword ptr [esi+4],	ecx
		add		ecx,				dword ptr [esi]
		add		ecx,				11
		;and save all this
		INVOKE	WriteFile,			hFilePrj,esi,ecx,ADDR Answer,0
		or		eax,				eax
		jz		IesireErr
	.ENDW
	INVOKE	SetFilePointer,		hFilePrj,0,0,FILE_BEGIN
	;encoding
	INVOKE	GetFileSize,			hFilePrj,0
	cmp		eax,					-1
	je		IesireErr
	mov		CounterVar,					eax
	mov		IdxElemL,			0
	.WHILE	CounterVar>1000h
		INVOKE	ReadFile,			hFilePrj,esi,1000h,ADDR Answer,0
		or		eax,				eax
		jz		IesireErr
		xor		edx,				edx
		mov		eax,				OFFSET PrjPassword
		xor		ecx,				ecx
		mov		cl,					byte ptr [eax]
		.WHILE	edx<1000h
			add		ecx,				edx
			ror		dword ptr [esi+edx],cl
			add		edx,				4
		.ENDW
		INVOKE	SetFilePointer,		hFilePrj,IdxElemL,0,FILE_BEGIN
		INVOKE	WriteFile,			hFilePrj,esi,1000h,ADDR Answer,0
		or		eax,				eax
		jz		IesireErr
		sub		CounterVar,				1000h
		add		IdxElemL,			1000h
	.ENDW
	INVOKE	ReadFile,			hFilePrj,esi,CounterVar,ADDR Answer,0
	or		eax,				eax
	jz		IesireErr
	xor		edx,				edx
	mov		eax,				OFFSET PrjPassword
	xor		ecx,				ecx
	mov		cl,					byte ptr [eax]
	.WHILE	edx<CounterVar
		add		ecx,				edx
		ror		byte ptr [esi+edx],cl
		add		edx,				1
;		ror		dword ptr [esi+edx],cl
;		add		edx,				4
	.ENDW
	INVOKE	SetFilePointer,		hFilePrj,IdxElemL,0,FILE_BEGIN
	INVOKE	WriteFile,			hFilePrj,esi,CounterVar,ADDR Answer,0
	or		eax,				eax
	jz		IesireErr
	
ret
IesireErr:
;error message
INVOKE	MessageBox,		0,ADDR Err_01,0,MB_OK or MB_ICONERROR
ret
SavePrjToDisk		endp











